<?php
/*
 * Copyright(c) 2000-2006 LOCKON CO.,LTD. All Rights Reserved.
 *
 * http://www.lockon.co.jp/
 */
$SC_GRAPHLINE_DIR = realpath(dirname( __FILE__));
require_once($SC_GRAPHLINE_DIR . "/SC_GraphBase.php");	

// ޤ饹
class SC_GraphLine extends SC_GraphBase{
	var $area_width;
	var $area_height;
	var $ygrid_on;
	var $graph_max;		// դΥꥢ(Yĺ)
	var $arrXLabel;	
	var $XLabelAngle;	// X٥	
	var $XTitle;		// Xȥ
	var $YTitle;		// Yȥ
	var $arrDataList;	// եǡǼ
	var $arrPointList;	// ޤɸǼ
	var $line_max;		// ʣξ˲ûƤ
	
	var $x_margin;
	var $y_margin;
			
    // 󥹥ȥ饯
	function SC_GraphLine(
		$bgw = BG_WIDTH, $bgh = BG_HEIGHT, $left = LINE_LEFT, $top = LINE_TOP,
		$area_width = LINE_AREA_WIDTH, $area_height = LINE_AREA_HEIGHT) {
		parent::SC_GraphBase($bgw, $bgh, $left, $top);	
		$this->area_width = $area_width;
		$this->area_height = $area_height;
		$this->ygrid_on = true;
		$this->line_max = 0;
		$this->graph_max = 0;
		$this->XLabelAngle = 0;
		$this->x_margin = 0;
		$this->y_margin = 0;
	}
	
	// X٥γ٥å
	function setXLabelAngle($Angle) {
		$this->XLabelAngle = $Angle;
	}
	
	// Yȥ
	function drawYTitle() {
		// Y˥ȥ
		if($this->YTitle != "") {
			$text_width = $this->getTextWidth($this->YTitle, FONT_SIZE);
			$x_pos = $this->left - ($text_width / 2);
			$y_pos = $this->top - FONT_SIZE - LINE_YTITLE_PAD;		
			$this->setText(FONT_SIZE, $x_pos, $y_pos, $this->YTitle);
		}
	}
	
	// Xȥ
	function drawXTitle() {
		// Y˥ȥ
		if($this->XTitle != "") {
			$text_width = $this->getTextWidth($this->XTitle, FONT_SIZE);
			$x_pos = $this->left + $this->area_width - ($text_width / 2) + 30;
			$y_pos = $this->top + $this->area_height + LINE_XTITLE_PAD;
			$this->setText(FONT_SIZE, $x_pos, $y_pos, $this->XTitle);
		}
	}
	
	// Y
	function drawYLine() {
		imageline($this->image, $this->left, $this->top, $this->left, $this->top + $this->area_height, $this->flame_color);
		// (ϼư)
		$size = $this->area_height / (LINE_Y_SCALE * 2);
		// 夫Ƥ
		$pos = 0;
		for($i = 0; $i < (LINE_Y_SCALE * 2); $i++) {
			// 
			if(($i % 2) == 0) {
				$sw = LINE_SCALE_SIZE;
				if($this->ygrid_on) {
					imageline($this->image, $this->left, $this->top + $pos, $this->left + $this->area_width, $this->top + $pos, $this->grid_color);
				}
			} else {
				$sw = LINE_SCALE_SIZE / 2;
			}
			imageline($this->image, $this->left, $this->top + $pos, $this->left + $sw, $this->top + $pos, $this->flame_color);
			$pos += $size;
		}
		// Yͤ
		$this->setYScale();
		$this->drawYTitle();	
	}
	
	// X
	function drawXLine($bar = false) {
		imageline($this->image, $this->left, $this->top + $this->area_height, $this->left + $this->area_width, $this->top + $this->area_height, $this->flame_color);
		$arrPointList = $this->arrPointList[0];
		$count = count($arrPointList);
		
		// դξȾꤺ餹
		if($bar) {
			$half_scale = intval($this->area_width / ($count + 1) / 2);
		} else {
			$half_scale = 0;
		}
		
		// ٥ɽ󥿡Х򻻽
		$interval = ceil($count / LINE_XLABEL_MAX);	// ڤ夲				
		for($i = 0; $i < $count; $i++) {
			// X
			$x = $arrPointList[$i][0];
			$pos = $this->top + $this->area_height;
			imageline($this->image, $x - $half_scale, $pos, $x - $half_scale, $pos - LINE_SCALE_SIZE,  $this->flame_color);			
			// ٥
			if(($i % $interval) == 0) {
				$text_width = $this->getTextWidth($this->arrXLabel[$i], FONT_SIZE);
				$x_pos = $x;
				
				if ($bar) $bar_margin = -15;

				$this->setText(FONT_SIZE, $x_pos + $this->x_margin + $bar_margin, $pos + FONT_SIZE + $this->y_margin, $this->arrXLabel[$i], NULL, $this->XLabelAngle);
			}
		}
		
		// դξϺǸɲä
		if($bar) {
			imageline($this->image, $x + $half_scale, $pos, $x + $half_scale, $pos - LINE_SCALE_SIZE,  $this->flame_color);	
		}
		
		$this->drawXTitle();
	}
		
	// åɽ
	function setYGridOn($ygrid_on) {
		$this->ygrid_on = $ygrid_on;
	}
	
	// ݥȤ
	function setMark($line_no, $left, $top, $size = LINE_MARK_SIZE) {
		// ѴƤ
		$size += $size % 2;
		$array = array(
			$left, $top - ($size / 2),
			$left + ($size / 2), $top,
			$left, $top + ($size / 2),
			$left - ($size / 2), $top,
		);		
		imagefilledpolygon($this->image, $array, 4, $this->arrColor[$line_no]);
		imagepolygon($this->image, $array, 4, $this->flame_color);
 		imagesetpixel ($this->image, $left, $top + ($size / 2), $this->flame_color);
	}	
	
	// Yͤ
	function setYScale() {
		// 1
		$number = intval($this->graph_max / LINE_Y_SCALE);				
		// 
		$size = $this->area_height / LINE_Y_SCALE;
		$pos = 0;
		for($i = 0; $i <= LINE_Y_SCALE; $i++) {
			$snumber = $number * (LINE_Y_SCALE - $i);
			$disp_number = number_format($snumber);
			$num_width = $this->getTextWidth($disp_number, FONT_SIZE);
			$this->setText(FONT_SIZE, $this->left - $num_width - 2, $this->top + $pos - (FONT_SIZE / 2), $disp_number);
			$pos += $size;
		}
	}
	
	// 
	function setMax($arrData) {
		// ǡκͤ롣
		$data_max = max($arrData);
		// 10βܤ
		$figure = strlen($data_max) - 1;
		// η׻
		$tenval = pow(10, $figure);
		// վǤκͤ
		$this->graph_max = $tenval * (intval($data_max / $tenval) + 1);
		// ͤ10̤ξб
		if($this->graph_max < 10) {
			$this->graph_max = 10;
		}	
	}
	
	// դ
	function drawGraph() {
		// طʤ
		$this->drawYLine();
		$this->drawXLine();
		
		// ޤ
		for($i = 0; $i < $this->line_max; $i++) {
			$this->drawLine($i);
		}
		
		// ޡ
		for($i = 0; $i < $this->line_max; $i++) {
			$this->drawMark($i);
		}
		
		// ٥
		for($i = 0; $i < $this->line_max; $i++) {
			$this->drawLabel($i);		
		}

		// 
		$this->drawLegend();	
	}
	
	// 饤褹
	function drawLine($line_no) {
		$arrPointList = $this->arrPointList[$line_no];
		
		$count = count($arrPointList);
		for($i = 0; $i < $count; $i++) {
			$x = $arrPointList[$i][0];
			$y = $arrPointList[$i][1];
			if(isset($arrPointList[$i + 1])) {
				$next_x = $arrPointList[$i + 1][0];
				$next_y = $arrPointList[$i + 1][1];
				imageline($this->image, $x, $y, $next_x, $next_y, $this->arrColor[$line_no]);
			}
		}
	}
	
	// ޡ褹
	function drawMark($line_no) {
		$arrPointList = $this->arrPointList[$line_no];
		$count = count($arrPointList);
		for($i = 0; $i < $count; $i++) {
			$x = $arrPointList[$i][0];
			$y = $arrPointList[$i][1];			
			$this->setMark($line_no, $x, $y);
		}
	}
	
	// ٥褹
	function drawLabel($line_no) {
		$arrData = $this->arrDataList[$line_no];
		$arrPointList = $this->arrPointList[$line_no];
		$count = count($arrPointList);
		for($i = 0; $i < $count; $i++) {
			$x = $arrPointList[$i][0];
			$y = $arrPointList[$i][1];
			$text_width = $this->getTextWidth(number_format($arrData[$i]), FONT_SIZE);
			$y_pos = $y - FONT_SIZE - 5;
			$x_pos = $x - $text_width / 2;
			$this->setText(FONT_SIZE, $x_pos, $y_pos, number_format($arrData[$i]));
		}
	}
	
	// ǡ򥻥åȤ
	function setData($arrData) {
		$this->arrDataList[$this->line_max] = array_values((array)$arrData);
		$this->setMax($this->arrDataList[$this->line_max]);
		// ͤѴΨ
		$rate = $this->area_height / $this->graph_max;
		// Ψ׻
		$count = count($this->arrDataList[$this->line_max]);
		$scale_width = $this->area_width / ($count + 1);		
		$this->arrPointList[$this->line_max] = array();
		for($i = 0; $i < $count; $i++) {
			// Xɸ
			$x = intval($this->left + ($scale_width * ($i + 1)));
			// Yɸ
			$y = intval($this->top + $this->area_height - ($this->arrDataList[$this->line_max][$i] * $rate));
			// XYɸ¸
			$this->arrPointList[$this->line_max][] = array($x, $y);
		}
		$this->line_max++;
	}
	
	// X٥򥻥åȤ
	function setXLabel($arrXLabel) {
		$this->arrXLabel = array_values((array)$arrXLabel);
	}
	
	// Xȥ򥻥åȤ
	function setXTitle($title) {
		$this->XTitle = $title;
	}
	
	// Yȥ򥻥åȤ
	function setYTitle($title) {
		$this->YTitle = $title;
	}	
}
?>